Subject: Re: bug#66117: 30.0.50; `find-buffer-visiting' is slow when opening large number of buffers

From: Eli Zaretskii <[email-masked]>
Date: Sun, 17 Dec 2023 12:36:59 +0200

> From: Ihor Radchenko <[email-masked]>
> Cc: Stefan Monnier <[email-masked]>, [email-masked],
>  [email-masked], [email-masked]
> Date: Sun, 17 Dec 2023 10:31:50 +0000
> 
> Eli Zaretskii <[email-masked]> writes:
> 
> >> AFAIK this is a purely internal change with no visible effect at the
> >> ELisp level
> 
> > It sounds like there will be some effect on some Lisp programs, at
> > least in some cases, and if so, we should mention those cases, even if
> > we think they are rare.
> 
> We have discussed a number of approaches to handle the let-binding
> performance and to handle sometimes-confusing behaviour of
> `case-fold-search'. Most of them had problems with breaking the existing
> behaviour or potentially causing unexpected side effects. Except the one
> I used in the patch.
> 
> The messages you linked to discuss problems with _other_ proposed
> approaches.

Maybe I'm confused, but won't this change have at least _some_ effect
on Lisp programs?  For example, what about this fragment from the
ELisp manual, which describes the effect of
make-variable-buffer-local:

     A peculiar wrinkle of this feature is that binding the variable
     (with ‘let’ or other binding constructs) does not create a
     buffer-local binding for it.  Only setting the variable (with ‘set’
     or ‘setq’), while the variable does not have a ‘let’-style binding
     that was made in the current buffer, does so.

Will this case work the same after the change as it did before?